/*
	 hex83p.c
	 Source file to create hex83p.dll
	 Assembly Studio plug-in to output an Asm program
	to an Intel Hex format (.hex) file for the TI-83+

	 (c) 1999 David Phillips
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

/* note that windows routines are used only for the About command */
#include <windows.h>
#include <winuser.h>

__declspec(dllexport) const char *GetPluginDescription()
{
	return("Ti-83+ application (.hex) file");
}

__declspec(dllexport) void About()
{
	MessageBox( NULL,
		"Intel Hex (.hex) file export for Ti-83+ applications\n"
		"Assembly Studio plugin\n"
		"(c) 1999 David Phillips",
		"About hex83p.dll", MB_OK);
}

//__declspec(dllexport) void Options()
//{
//}

__declspec(dllexport) int SavePrgmFile(unsigned char *pData, unsigned nLength, const char *szFilename, char *szExt)
{
	FILE *fp;
	unsigned char pbuff[128], cs;
	unsigned long addr, row, len, i, x;
	
	/* add extension to filename and open file */
	strcpy(pbuff, szFilename);
	strcat(pbuff, ".hex");
	if ((fp = fopen(pbuff, "w")) == NULL)
		return(0);

	/* set address to $4000 for Ti-83+ applications */
	addr = 0x4000;

	/* write out data */
	i = 0;
	for(row = 0; row < (nLength / 16) + 1; row++)
	{
		if (nLength - i > 16)
			len = 16;
		else
				len = nLength - i;
		cs = (char)(len + (addr >> 8) + (addr & 0xFF));
		fprintf(fp, ":%02X", len);
		fprintf(fp, "%04X00", addr);
		for(x = 0; x < len; x++)
		{
			cs += pData[i];
			fprintf(fp, "%02X", pData[i++]);
		}
		fprintf(fp, "%02X\n", (unsigned char)(256 - cs));
		addr += 16;
	}
	fprintf(fp, ":00000003FD\n:00000001FF\n");

	/* close the file */
	fclose(fp);

	/* return given extension */
	if (szExt != NULL)
		strcpy(szExt, ".hex");

	return(1);
}
