; Sprite Demo
; by David Phillips <david@acz.org>

#define APPNAME "Spr Demo"

#include "apphead.asm"


VideoRam = _plotSScreen


 bcall _ClrLCDFull
 bcall _GRBUFCLR

 ld bc,(23<<8)+19
 ld hl,Sprite
 call PutSprite

 bcall _GRBUFCPY
 bcall _GetKey
 B_JUMP(_JForceCmdNoChar)


; hl = sprite, bc = x,y
PutSprite:
 push hl
 pop ix
 call FindAddress
 ld de,VideoRam
 add hl,de
 ld c,a
 ld b,8
PutSpriteLoop:
 push bc
 ld d,(ix+0)
 ld a,(ix+8)
 inc ix
 cpl
 ld b,a
 ld e,0
 ld a,c
 ld c,$ff
 or a
 jr z,PutSpriteShiftDone 
PutSpriteShift:
 scf
 rr b
 rr c
 srl d
 rr e
 dec a
 jr nz,PutSpriteShift
PutSpriteShiftDone:
 ld a,b
 and (hl)
 or d
 ld (hl),a
 inc hl
 ld a,c
 and (hl)
 or e
 ld (hl),a
 ld de,11
 add hl,de
 pop bc
 djnz PutSpriteLoop
 ret 

FindAddress:
 ld a,c
 add a,a
 add a,a
 ld h,0
 ld l,a
 ld d,h
 ld e,l
 add hl,hl
 add hl,de
 ld a,%11111000
 and b
 ld e,a
 add hl,de
 ld a,%00000111
 and b
 ret

 

Sprite:
	.db %00000000
	.db %01111110
	.db %00000100
	.db %00001000
	.db %00010000
	.db %00100000
	.db %01111110
	.db %00000000
	.db %11111111
	.db %11111111
	.db %11111111
	.db %00111110
	.db %01111100
	.db %11111111
	.db %11111111
	.db %11111111

.end